<template>
  <div class="container mx-auto">
    <div
      class="mb-5 md:flex md:flex-row md:justify-center relative text-center"
      v-show="hasBackButton"
    >
      <div class="md:absolute left-0">
        <Button label="Retour" @click="back()" />
      </div>
    </div>

    <div class="mb-5 md:flex md:flex-row md:justify-center relative text-center">
      <div class="md:absolute left-0" v-show="reSubmitRoadtrip !== null">
        <Button label="Recalculer ce road trip" @click="reSubmitRoadtrip()" />
      </div>

      <div @click="editNameMode = true" class="w-full my-3 md:my-0">
        <h1 v-show="!editNameMode" class="text-2xl">{{ roadTrip.name }}</h1>
        <input
          v-show="editNameMode"
          v-model="roadTrip.name"
          class="appearance-none rounded-lg w-3/4 md:w-1/4 py-3 border border-gray-300 placeholder-gray-300 text-gray-900 focus:outline-none focus:ring-yellow-500 focus:border-yellow-500 focus:z-10 sm:text-sm"
          @keydown.enter="() => (editNameMode = false) | save()"
        />
        <font-awesome-icon
          class="ml-2 cursor-pointer hover:bg-blue-400 p-1 rounded-lg"
          icon="edit"
          size="lg"
          @click.stop="editNameMode = !editNameMode"
        />
      </div>

      <div class="md:absolute right-0">
        <Button
          :label="
            'Sauvergarder ce ' +
            (roadTrip.type === 'cityTour' ? 'CityTour' : 'RoadTrip')
          "
          @click="() => (editNameMode = false) | save()"
        />
      </div>
    </div>

    <div>
      <div class="lg:flex lg:flex-row lg:gap-10">
        <div class="w-full lg:w-4/5 mb-5 z-40">
          <l-map style="height: 700px" :zoom="zoom" :center="center">
            <l-tile-layer :url="url" :attribution="attribution"></l-tile-layer>
            <l-markers
              v-for="marker in markers"
              :key="marker.id"
              :marker="marker"
            />
            <l-routing-machine :waypoints="waypoints" />
          </l-map>
        </div>
        <div class="w-full lg:w-1/5">
          <div style="height: 700px" class="overflow-auto">
            <div
              :key="POIByDay.id"
              v-for="(POIByDay, index) in POIs"
              class="text-center mb-3 border border-yellow-500 bg-white p-4 shadow-lg rounded-lg"
            >
              <h3 class="text-yellow-500 font-bold">
                {{ index === "0" ? "Hôtel" : "Jour " + index }}
              </h3>
              <ul>
                <li :key="poi.name" v-for="poi in POIByDay">
                  <font-awesome-icon :icon="poi.icon" :class="`mr-2 ${getColorByPOIType(poi.POIType)}`" />
                  {{ poi.name }} ({{ poi.POIType }})
                  <p class="text-xs italic" v-if="poi.tags">{{ poi.tags.join(", ") }}</p>
                  <p class="text-xs italic" v-if="poi.categories">{{ poi.categories.join(", ") }}</p>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { LMap, LTileLayer } from "vue2-leaflet";
import "leaflet/dist/leaflet.css";
import LMarkers from "@/components/Leaflet/LMarkers.vue";
import LRoutingMachine from "@/components/Leaflet/LRoutingMachine";
import Button from "@/components/Button.vue";

export default {
  name: "ViewRoadTrip",
  inject: ['translation'],
  components: {
    LMap,
    LTileLayer,
    LMarkers,
    LRoutingMachine,
    Button,
  },
  props: {
    roadTrip: Object,
    save: Function,
    hasBackButton: {
      type: Boolean,
      default: false,
    },
    reSubmitRoadtrip: {
      type: Function,
      default: null
    },
    back: Function,
  },
  data: () => ({
    url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",
    attribution:
      '&copy; <a target="_blank" href="http://osm.org/copyright">OpenStreetMap</a> contributors',
    zoom: 6,
    center: [47.53092519322762, 2.3734923973713276],
    POIColorsByType: {
      POI: "blue",
      restaurant: "red",
      hostel: "gold",
    },
    textByPOIType: {
      POI: "Etape",
      restaurant: "Restaurant",
      hostel: "Hôtel",
    },
    iconByPOIType: {
      POI: "map-pin",
      restaurant: "utensils",
      hostel: "bed",
    },
    editNameMode: false,
  }),
  beforeMount() {
    if (this.roadTrip === null) {
      this.$router.push("/");
    }
  },
  computed: {
    markers() {
      if (this.roadTrip === null) return [];
      return [
        ...(this.roadTrip.type === "AToB"
          ? [
              {
                id: "A",
                coordinates: [this.roadTrip.from.lat, this.roadTrip.from.lng],
                color: "grey",
                popup: "Départ",
              },
            ]
          : []),
        ...this.roadTrip.road.map(({ id, lat, lng, name, POIType }) => ({
          id: id,
          coordinates: [lat, lng],
          color: this.POIColorsByType[POIType],
          popup: name,
        })),
        ...(this.roadTrip.type === "AToB"
          ? [
              {
                id: "B",
                coordinates: [this.roadTrip.to.lat, this.roadTrip.to.lng],
                color: "grey",
                popup: "Arrivée",
              },
            ]
          : []),
        ...(this.roadTrip.type === "cityTour" && this.roadTrip.hostel
          ? [
              {
                id: this.roadTrip.hostel.id,
                coordinates: [
                  this.roadTrip.hostel.lat,
                  this.roadTrip.hostel.lng,
                ],
                color: this.POIColorsByType[this.roadTrip.hostel.POIType],
                popup: this.roadTrip.hostel.name,
              },
            ]
          : []),
      ];
    },
    waypoints() {
      if (this.roadTrip === null) return [];
      return [
        ...(this.roadTrip.type === "AToB" ? [this.roadTrip.from] : []),
        ...this.roadTrip.road.map(({ lat, lng }) => ({
          lat,
          lng,
        })),
        ...(this.roadTrip.type === "AToB" ? [this.roadTrip.to] : []),
      ];
    },
    POIs() {
      if (this.roadTrip === null) return [];
      return [
        ...this.roadTrip.road.map(
          ({ name, POIType, nbDay, tags, categorySet }) => ({
            name,
            POIType: this.textByPOIType[POIType],
            nbDay,
            icon: this.iconByPOIType[POIType],
            ...((tags && tags.length > 0) ? {tags: tags.map(tag => this.translation.displayTagOrCategory(tag, 'tag'))} : {}),
            ...((categorySet && categorySet.length > 0) ? {categories: categorySet.map(id => this.translation.displayTagOrCategory(id, 'category'))} : {}),
          })
        ),
        ...(this.roadTrip.type === "cityTour" && this.roadTrip.hostel
          ? [
              {
                name: this.roadTrip.hostel.name,
                POIType: this.textByPOIType[this.roadTrip.hostel.POIType],
                nbDay: 0,
                icon: this.iconByPOIType[this.roadTrip.hostel.POIType],
                categories: this.roadTrip.hostel.categorySet.map(id => this.translation.displayTagOrCategory(id, 'category')),
              },
            ]
          : []),
      ].reduce(function (r, a) {
        r[a.nbDay] = r[a.nbDay] || [];
        r[a.nbDay].push(a);
        return r;
      }, Object.create(null));
    },
  },
  methods: {
    getColorByPOIType(POIType) {
      if (POIType === "Etape") return "text-blue-500";
      else if (POIType === "Restaurant") return "text-red-600";
      else if (POIType === "Hôtel") return "text-yellow-300";
    },
  }
};
</script>

<style scoped></style>
